%{!?python_sitelib: %define python_sitelib %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib()")}

%define _cachedir /var/cache
%define _logdir /var/log

##########################################################################
# Set default freevo parameters
%define geometry 768x576
%define display  x11

##########################################################################


%if %{?_without_us_defaults:0}%{!?_without_us_defaults:1}
%define tv_norm  ntsc
%define chanlist us-cable
%else
%define tv_norm  pal
%define chanlist europe-west
%endif

##########################################################################

Name:           freevo
Version:        1.7.5
Release:        1%{?dist}
Summary:        Freevo is an open-source home theatre

Group:          Applications/Multimedia
License:        GPLv2+
URL:            http://freevo.sourceforge.net/
Source0:        http://downloads.sourceforge.net/freevo/freevo-%{version}.tar.gz
Patch0:         freevo-1.7.4-default_fonts.patch
Patch1:         freevo-1.7.4-freevo_user.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildArch:      noarch

BuildRequires: python-devel
BuildRequires: pygame, python-imaging
BuildRequires: python-twisted
BuildRequires: python-twisted-web
BuildRequires: python-kaa-base, python-kaa-metadata, python-kaa-imlib2
BuildRequires: python-BeautifulSoup
BuildRequires: SDL-devel
Requires: SDL >= 1.2.6, SDL_image >= 1.2.3, SDL_ttf >= 2.0.6, SDL_mixer >= 1.2.5, SDL_sound
Requires: smpeg >= 0.4.4, freetype >= 2.1.4
Requires: libjpeg >= 6b, libexif >= 0.5.10
Requires: python >= 2.4, pygame >= 1.6, PyXML, python-imaging
Requires: python-kaa-base, python-kaa-metadata, python-kaa-imlib2
Requires: mx >= 2.0.5, python-numeric >= 23.1,
Requires: python-twisted >= 1.3.0
Requires: python-BeautifulSoup
Requires: python-sqlite2
Requires: python-twisted-web
Requires(pre): shadow-utils
Obsoletes: freevo17

# We try to set xine by default
Requires: xine
Requires: xine-lib-extras-nonfree
# But mplayer is mandatory anyway
Requires: mplayer

%if "%fedora" < "7"
BuildRequires: python-elementtree
Requires: python-elementtree
%endif

%if "%fedora" > "7"
BuildRequires: util-linux-ng
Requires: util-linux-ng
%else
BuildRequires: util-linux
Requires: util-linux
%endif

# Fonts that are needed
Requires: dejavu-fonts-experimental
Requires: bitstream-vera-fonts

# We split the -boot package so the system default setup
# will not conflict with the user current setup

%description
Freevo is a Linux application that turns a PC with a TV capture card
and/or TV-out into a standalone multimedia jukebox/VCR. It builds on
other applications such as xine, mplayer, tvtime and mencoder to play
and record video and audio.

%package boot
Summary: Files to enable a standalone Freevo system (started from initscript)
Group: Applications/Multimedia
Requires:  %{name} = %{version}-%{release}
Obsoletes: freevo17-boot
Requires: logrotate

%description boot
Freevo is a Linux application that turns a PC with a TV capture card
and/or TV-out into a standalone multimedia jukebox/VCR. It builds on
other applications such as mplayer and mencoder to play and record
video and audio.

Note: This installs the initscripts necessary for a standalone Freevo system.



%prep
%setup -q
%patch0 -p1 -b .default_font
%patch1 -p1 -b .freevo_user
# Used for SVN version only
#./autogen.sh

# Docs fixes in prep
rm -rf Docs/distribution/INSTALL

# Fix default path for Freevo
sed -i -e 's|/usr/local/freevo|%{_bindir}|' boot/boot_config

# Fix file-not-utf8
for i in Docs/plugins/itv.txt ChangeLog ; do
cp -pr $i $i.not-utf8
iconv -f ISO_8859-1 -t UTF8 $i.not-utf8 > $i
touch -r $i.not-utf8 $i
rm $i.not-utf8
done

%build
%{__python} setup.py build


%install
rm -rf $RPM_BUILD_ROOT
%{__python} setup.py install -O1 --skip-build --root $RPM_BUILD_ROOT
find $RPM_BUILD_ROOT -name '*.po' -exec rm -f {} ';'

# Removed unneeded shebang
for i in $(find {$RPM_BUILD_ROOT%{python_sitelib},$RPM_BUILD_ROOT%{_datadir}/freevo/htdocs} -name "*py") ;do
sed -i -e 's|#!/usr/bin/env python|###|' $i
sed -i -e 's|#!/usr/bin/python|###|' $i
done

# Create config directories and files...
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/freevo
# The following is needed to let RPM know that the files should be backed up
touch $RPM_BUILD_ROOT%{_sysconfdir}/freevo/freevo.conf
# Copy local_conf.py.example
install -pm 0644 local_conf.py.example $RPM_BUILD_ROOT%{_sysconfdir}/freevo/local_conf.py
install -pm 0644 local_conf.py.example $RPM_BUILD_ROOT%{_datadir}/freevo/local_conf.py.example

# boot scripts
mkdir -p $RPM_BUILD_ROOT%{_initrddir}
mkdir -p $RPM_BUILD_ROOT%{_bindir}
install -m 755 boot/freevo $RPM_BUILD_ROOT%{_initrddir}
#install -m 755 boot/freevo_dep $RPM_BUILD_ROOT%{_initrddir}
install -m 755 boot/recordserver $RPM_BUILD_ROOT%{_initrddir}/freevo_recordserver
install -m 755 boot/webserver $RPM_BUILD_ROOT%{_initrddir}/freevo_webserver
install -m 755 boot/recordserver_init $RPM_BUILD_ROOT%{_bindir}/freevo_recordserver_init
install -m 755 boot/webserver_init $RPM_BUILD_ROOT%{_bindir}/freevo_webserver_init
install -m 644 boot/boot_config $RPM_BUILD_ROOT%{_sysconfdir}/freevo/

# cache and log directories
mkdir -p $RPM_BUILD_ROOT%{_logdir}/freevo
mkdir -p $RPM_BUILD_ROOT%{_cachedir}/freevo
mkdir -p $RPM_BUILD_ROOT%{_cachedir}/freevo/{thumbnails,audio,vfs,image_cache,xmltv,xmltv/logos}
mkdir -p $RPM_BUILD_ROOT%{_localstatedir}/lib/%{name}
#mkdir -p $RPM_BUILD_ROOT%{_cachedir}/xmltv/logos
chmod 777 $RPM_BUILD_ROOT%{_cachedir}/freevo/{thumbnails,audio,vfs,image_cache,xmltv,xmltv/logos}
chmod 777 $RPM_BUILD_ROOT%{_logdir}/freevo

mkdir -p $RPM_BUILD_ROOT%{_datadir}/%{name}/contrib
cp -av contrib/lirc $RPM_BUILD_ROOT%{_datadir}/%{name}/contrib
cp -av contrib/plugins $RPM_BUILD_ROOT%{_datadir}/%{name}/contrib
cp -av contrib/video $RPM_BUILD_ROOT%{_datadir}/%{name}/contrib

# fix perms for contrib scripts
chmod 0755 $RPM_BUILD_ROOT%{_datadir}/freevo/contrib/video/plugins/appletrailers/applelib.py

# Tweak for current package 1.7.5
rm -rf $RPM_BUILD_ROOT%{_datadir}/doc/freevo-1.7.4/

# Remove already provided fonts
#rm -rf $RPM_BUILD_ROOT%{_datadir}/freevo/fonts/DejaVu*.ttf
#rm -rf $RPM_BUILD_ROOT%{_datadir}/freevo/fonts/Vera*.ttf

# Add logrotate support
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/logrotate.d/
cat > $RPM_BUILD_ROOT%{_sysconfdir}/logrotate.d/%{name}-boot << EOF
/var/log/freevo/* {
    weekly
    rotate 5
    copytruncate
    compress
    notifempty
    missingok
}
EOF


%find_lang %{name}


%clean
rm -rf $RPM_BUILD_ROOT

%pre
getent group freevo >/dev/null || groupadd -r freevo
getent passwd freevo >/dev/null || \
useradd -r -g freevo -d %{_localstatedir}/lib/%{name} -s /sbin/nologin \
    -c "Freevo recordserver and webserver" freevo || :

%post
if [ $1 -eq 1 ]; then
if [ -x %{_bindir}/fc-cache ]; then
%{_bindir}/fc-cache -f %{_datadir}/freevo/fonts
fi
fi || :


%post boot
# Automatic update support
if [ -x %{_sysconfdir}/freevo/local_conf.py ]; then
  %{_bindir}/freevo convert_config %{_sysconfdir}/freevo/local_conf.py -w
fi
# Add the service if not present, but don't automatically invoke it
# user has to enable it via ntsysv
if [ -x /sbin/chkconfig ]; then
  if [ `chkconfig --list freevo 2> /dev/null |fgrep -c freevo` -eq 0 ]; then
     chkconfig --add freevo
     chkconfig --levels 234 freevo off
  fi
  if [ `chkconfig --list freevo_recordserver 2> /dev/null |fgrep -c freevo_recordserver` -eq 0 ]; then
     chkconfig --add freevo_recordserver
     chkconfig --levels 234 freevo_recordserver off
  fi
  if [ `chkconfig --list freevo_webserver 2> /dev/null |fgrep -c freevo_webserver` -eq 0 ]; then
     chkconfig --add freevo_webserver
     chkconfig --levels 234 freevo_webserver off
  fi
fi || :


%preun boot
if [ "$1" == 0 ] ; then
  /sbin/service freevo_webserver stop
  /sbin/service freevo_recordserver stop
  /sbin/service freevo stop
  if [ -x /sbin/chkconfig ]; then
     chkconfig --del freevo
     chkconfig --del freevo_recordserver
     chkconfig --del freevo_webserver
  fi
fi || :

%postun
if [ $1 -eq 1 ]; then
if [ -x %{_bindir}/fc-cache ]; then
%{_bindir}/fc-cache -f %{_datadir}/freevo/fonts
fi
fi || :



%files -f %{name}.lang
%defattr(-,root,root,-)
%doc ChangeLog COPYING FAQ README TODO freevo_config.py
%doc Docs/* local_conf.py.example
%dir %{_sysconfdir}/freevo
%{_bindir}/freevo
%{_datadir}/freevo/
%{python_sitelib}/*
%attr(777,freevo,freevo) %dir %{_logdir}/freevo
%attr(777,freevo,freevo) %dir %{_cachedir}/freevo
%attr(777,freevo,freevo) %dir %{_cachedir}/freevo/thumbnails
%attr(777,freevo,freevo) %dir %{_cachedir}/freevo/audio
%attr(777,freevo,freevo) %dir %{_cachedir}/freevo/image_cache
%attr(777,freevo,freevo) %dir %{_cachedir}/freevo/vfs
%attr(777,freevo,freevo) %dir %{_cachedir}/freevo/xmltv
%attr(777,freevo,freevo) %dir %{_cachedir}/freevo/xmltv/logos
%attr(777,freevo,freevo) %dir %{_localstatedir}/lib/%{name}

%files boot
%defattr(-,root,root,-)
%{_initrddir}/*
%{_bindir}/freevo_*
%config(noreplace) %{_sysconfdir}/logrotate.d/%{name}-boot
%config(noreplace) %{_sysconfdir}/freevo/boot_config
%config(noreplace) %{_sysconfdir}/freevo/freevo.conf
%config(noreplace) %{_sysconfdir}/freevo/local_conf.py
%exclude %{_sysconfdir}/freevo/local_conf.py?



%changelog
* Thu Dec 27 2007 kwizart < kwizart at gmail.com > - 1.7.5-1
- Update to 1.7.5

* Thu Nov 15 2007 kwizart < kwizart at gmail.com > - 1.7.4-1
- Update to 1.7.4 (Enable twisted 2.5).
- Move back root configs to boot
- Remove already provided fonts
- Add logrotate support for freevo-boot
- Add freevo user/group (nologin is default secure)
- Fix freevo-boot postun (stop services)
- Fix file-not-utf8
- Add automatic convert_support for -boot
- Add xine to be the default player (prevent the mplayer scale bug)

* Mon Oct 22 2007 kwizart < kwizart at gmail.com > - 1.7.3-3
- Conflict will python-twisted-web >= 0.7.0
- Move some files from boot to main
- Add Requires SDL_sound

* Mon Oct 01 2007 kwizart < kwizart at gmail.com > - 1.7.3-2
- Add python-image and python-sqlite2 Requirement

* Wed Aug 01 2007 kwizart < kwizart at gmail.com > - 1.7.3-1
- Update to 1.7.3
- Add system config files in -boot

* Tue Jun  5 2007 kwizart < kwizart at gmail.com > - 1.7.2-2
- Add patch to help building with python 2.5

* Fri Jun  2 2007 kwizart < kwizart at gmail.com > - 1.7.2-1
- Update to 1.7.2
- Add missing BR python-kaa-imlib2 python-imaging

* Fri May  4 2007 kwizart < kwizart at gmail.com > - 1.7.1-2
- Fix the Docs dir 

* Wed May  2 2007 kwizart < kwizart at gmail.com > - 1.7.1-1
- Update to 1.7.1

* Wed Apr 18 2007 kwizart < kwizart at gmail.com > - 1.7.0-1
- Cleaned spec for Fedora 

* Mon Feb 26 2007 TC Wan <tcwan@cs.usm.my>
- Built 1.7.0 for FC5 

* Wed Nov 29 2006 TC Wan <tcwan@cs.usm.my>
- Built 1.6.1 for FC5 

* Mon Oct 30 2006 TC Wan <tcwan@cs.usm.my>
- Built 1.6.0 for FC5 

* Tue May  2 2006 TC Wan <tcwan@cs.usm.my>
- Rebuilt 1.5.4 for FC5 

